/***********************头发**************************************************/
//发型编辑
function hairChange(i) {
	hairDataParse(frontHair,middleHair,backHair,"hairPart",hairData["hair"+i].frontSide,true);
	if(hairColorTag.color!=""){
		cartoonPerson.selectAll(".haircolor").attr("fill",hairColorTag.color);
	}
}
//头发颜色
function hairColorChange(color){
	hairColorTag.color=color;
	cartoonPerson.selectAll(".haircolor").attr("fill",hairColorTag.color,true);
}

/***********************脸型**************************************************/
//脸部
function faceChange(i) {
	expressDataParse(face,"facePart",faceData["face"+i].frontSide,true);
	if(faceColorTag.color!=""){
		cartoonPerson.selectAll(".skincolor").attr("fill",faceColorTag.color);
	}
}
//肤色改变
function faceColorChange(color){
	faceColorTag.color=color;
	cartoonPerson.selectAll(".skincolor").attr("fill",faceColorTag.color);
}

/***********************五官**************************************************/
//眉毛
function eyebrowChange(i){
	//expressDataParse(eyebrow,"eyebrowPart",eyebrowData["eyebrow"+i].frontSide,true);
	parseData(eyebrow,"eyebrowPart",eyebrowData["eyebrow"+i].frontSide,true, eyebrowTag);
}

//眼睛
function eyeChange(i) {
	//expressDataParse(eye,"eyePart",eyeData["eye"+i].frontSide,true);
	parseData(eye,"eyePart",eyeData["eye"+i].frontSide,true,eyeTag);
}

//鼻子
function noseChange(i){
	//expressDataParse(nose,"nosePart",noseData["nose"+i].frontSide,true);
	parseData(nose,"nosePart",noseData["nose"+i].frontSide,true, noseTag);
}

//嘴部编辑
function mouthChange(i){
	//expressDataParse(mouth,"mouthPart",mouthData["mouth"+i].frontSide,true);
	parseData(mouth,"mouthPart",mouthData["mouth"+i].frontSide,true, mouthTag);
}

/***********************配饰**************************************************/
//帽子
function hatChange(i){
//	expressDataParse(hat,"hatPart",hatData["hat"+i].frontSide,true);
	parseData(hat,"hatPart",hatData["hat"+i].frontSide,true, hatTag);
}

//发卡
function hairpinChange(i){
	// expressDataParse(hat,"hatPart",hatData["hat"+i].frontSide,true);
}

//眼镜
function glassChange(i){
	//expressDataParse(glass,"glassPart",glassData["glass"+i].frontSide,true);
	parseData(glass,"glassPart",glassData["glass"+i].frontSide,true,glassTag);
}

/***********************特征**************************************************/
//胡子
function beardChange(i){
	// expressDataParse(hat,"hatPart",hatData["hat"+i].frontSide,true);
}

//痣，疤
function moleScarChange(i){
	// expressDataParse(hat,"hatPart",hatData["hat"+i].frontSide,true);
}

/***********************身体**************************************************/
//上身 + 手势
function upperBodyChange(i){

	$(".bodyPart").remove();
	expressDataParse(upperbody,"upperbodyPart",upperBodyData["upperBody"+i].frontSide,true);

	if(faceColorTag.color!=""){
		cartoonPerson.selectAll(".skincolor").attr("fill",faceColorTag.color);
	}
}

// 下身
function lowerBodyChange(i){

	$(".bodyPart").remove();
	expressDataParse(lowerbody,"lowerbodyPart",lowerBodyData["lowerBody"+i].frontSide,true);

	if(faceColorTag.color!=""){
		cartoonPerson.selectAll(".skincolor").attr("fill",faceColorTag.color);
	}
}

//全身
// function allBodyChange(i){
// 	expressDataParse(body,"bodyPart",bodyData["body"+i].frontSide,true);
// }

//全身
function bodyChange(i){
	$(".upperbodyPart,.lowerbodyPart").remove();
	expressDataParse(allbody,"bodyPart",bodyData["body"+i].frontSide,true);
	if(faceColorTag.color!=""){
		cartoonPerson.selectAll(".skincolor").attr("fill",faceColorTag.color);
	}
}

//衣服
function clothChange(i){
	expressDataParse(cloth,"clothPart",clothData["cloth"+i].frontSide,true);
	cartoonPerson.selectAll(".skincolor").attr("fill",faceColorTag.color);
}

/***********************背景**************************************************/
//颜色+形状
//背景改变
function backgroundChange(i){
	var tem="bg"+i;
	$(".bgPart,.bgPart2,.bgPart3").remove();
	expressDataParse(background,"bgPart",backgroundData[tem].frontSide,true);
	$("#contentSVG").css("background",backgroundData[tem].frontSide.bgcolor);
	if(minWidth==winHeight&&backgroundData[tem].frontSide.repeat==1){
		expressDataParse(background2,"bgPart2",backgroundData["bgUse"].frontSide,true);
		background2.attr("transform","translate(-639,0)");
		expressDataParse(background3,"bgPart3",backgroundData["bgUse"].frontSide,true);
		background3.attr("transform","translate(639,0)");
		$(".bgUse").attr("fill",backgroundData[tem].frontSide.bgcolor);
	} else if(minWidth==winHeight&&backgroundData[tem].frontSide.repeat==2){
		expressDataParse(background2,"bgPart2",backgroundData[tem].frontSide,true);
		background2.attr("transform","translate(-639,0)");
		expressDataParse(background3,"bgPart3",backgroundData[tem].frontSide,true);
		background3.attr("transform","translate(639,0)");
	}
}

//建筑物 +　景点
function bgColorShapeChange(i){
	$(".bgPart").remove();
	expressDataParse(bgSvgLayer,"bgPart",backgroundData["bg"+i].frontSide,true);
}

function svgBackgroundFill(){
	var tem="bgUse";
	$(".contentBg,.contentBg2,.contentBg3").remove();
	expressDataParse(backgroundCenter,"contentBg",backgroundData[tem].frontSide,true);
	expressDataParse(backgroundLeft,"contentBg2",backgroundData[tem].frontSide,true);
	backgroundLeft.attr("transform","translate(-479,0)");
	expressDataParse(backgroundRight,"contentBg3",backgroundData[tem].frontSide,true);
	backgroundRight.attr("transform","translate(479,0)");
}

//文字气泡
////气泡改变
function bubbleChange(i){
	bubbleDataParse(bubble,"bubblePart",bubbleData["bubble"+i].frontSide,true);
}

//装饰
//爱好改变
function hobbyChange(i){
	expressDataParse(hobby,"hobbyPart",hobbyData["hobby"+i].frontSide,true);
	cartoonPerson.selectAll(".faceColor").attr("fill",faceColorTag.color);
}

/************************End**************************************************/

function haloChangeA(i){
	expressDataParse(haloA,"haloPart",haloData["halo"+i].frontSide,true);
}

//特征改变
function featureChange(i){
	expressDataParse(feature,"featurePart",featureData["feature"+i].frontSide,true);
}

//清除所有元素
function erase(){
	$(".bodyPart").remove();
	$(".bgPart").remove();
	$(".bgPart1").remove();
	$(".bgPart2").remove();
	$(".upperbodyPart,.lowerbodyPart").remove();
	
	$(".featurePart").remove();
	$(".clothPart").remove();
	$(".glassPart").remove();
	$(".hatPart").remove();
	$(".eyebrowPart").remove();
	$(".eyePart").remove();
	$(".nosePart").remove();
	$(".mouthPart").remove();
	$(".facePart").remove();
	$(".hairPart").remove();
}

////脸部编辑操作模块

//表情变换
function expressChange(i){
	if(i==0){
		cartoonPerson.select("#facial").attr("opacity",1);
	}else{
		cartoonPerson.select("#facial").attr("opacity",0);
	}
	expressDataParse2(express,express2,"expressPart",expressData["express"+i].frontSide,true);
}


//屏幕自适应
function resizeSVG(w,h) {
	winWidth = w;
 	winHeight = h;
 	
	d3.select("#contentSVG").attr("width",w)
		.attr("height",h);

	d3.select("#bgSVG").attr("width",w)
		.attr("height",h);
}

