	var focusObj; //焦点部位
	var currMoveStyle; //移动
	var MOVE_STYLE_FORBIDEN = -1;//大小位置都不能动
	var MOVE_STYLE_DEFAULT = 0;//默认大小位置都可以变化
	var MOVE_STYLE_SCALE_FORBIDEN = 1;//禁止缩放
	var MOVE_STYLE_MOVE_FORBIDEN = 2;//禁止移动
	var MOVE_STYLE_CROSS_MOVE_FORBIDEN = 3;//禁止横向移动
	var MOVE_STYLE_VERTICAL_MOVE_FORBIDEN = 4;//禁止竖向移动
	var MOVE_STYLE_SCALE_AND_VERTICAL_MOVE_FORBIDEN = 5;//禁止竖向移动和缩放
	var MOVE_STYLE_SCALE_AND_CROSS_MOVE_FORBIDEN = 6;//禁止横向移动和缩放
    var DEBUG = false;

	function parseTranslate(obj){
		var reg=/\-?[0-9]+\.?[0-9]*/g;
	    var trans = $(obj).attr("transform");

	  	if(typeof(trans) != "string"){
	    	return [0,0];
	    }
	    else{
	    	var strs = trans.split(" ");
	    	var ret = strs[0].match(reg);
	    	return ret;
	    }
	}

	function parseScale(obj){
		var reg=/\-?[0-9]+\.?[0-9]*/g;
   		 var trans = $(obj).attr("transform");

	  	if(typeof(trans) != "string"){
	    	return [1,1];
	    }
	    else{
	    	var strs = trans.split(" ");
	    	var ret = strs[1].match(reg);
            if (DEBUG) {
			     Log.d("touch ssssssss ret = "+ret);
            }
	    	return ret;
	    }
	}


	function changeFocusObj(obj){
		focusObj = obj;
	}

	function changeMoveStyle(currStyle){
		currMoveStyle = currStyle;
	}

	function getDistance(ev){
		var x = Math.abs(ev.touches[1].pageX-ev.touches[0].pageX);
		var y = Math.abs(ev.touches[1].pageY-ev.touches[0].pageY);
		var ret = Math.sqrt(parseFloat(x*x + y*y));
		return ret;
	}

	function parse2unit(v){
		return parseFloat(svgWidth*v/winWidth);
	}

	function registMoveEvent(){

   var moveX,moveY,startX,startY,endX,endY;
   var oldDistance = 0;
   var lastDistance = 0;
   var oldWidth = 0;

   var moveCount;
   var isDrag = false;
	 var isZoom = false;

	 var oldPosWhenScale = 0;
	 var oldScaleWhenScale = 1;//缩放时的当前缩放大小
	 var oldScaleWhenTran = 1; //拖拽时的当前缩放大小


  $("#contentDIV").on("touchstart",function(event){
    if (DEBUG) {
  	     Log.d("touch touchstart");
    }

  	var oldPos = parseTranslate(focusObj);

    if (DEBUG) {
	  Log.d("touch x = "+oldPos[0]+" y = "+oldPos[1]);
	  Log.d("touch start moveCount = "+moveCount);
    }

    if(event.touches.length == 1){
  		isDrag = true;
  		isZoom = false;
  	}else if(event.touches.length > 1){
  		isDrag = false;
  		isZoom = true;
  	}

  	moveCount = 0;
  	var s = parseScale($(focusObj))[0];

  	if(isDrag){
	      var touchPros = event.touches[0];
	      startX = touchPros.pageX;
	      startY = touchPros.pageY;
	      oldScaleWhenTran = s;
    }else if(isZoom){
      	oldDistance = getDistance(event);
      	lastDistance = oldDistance;
      	oldWidth = $(focusObj).width();
      	oldPosWhenScale = parseTranslate($(focusObj));
      	oldScaleWhenScale = s-1;
    }
    return true;
  });


 $("#contentDIV") .on("touchmove",function(event){
    if (DEBUG) {
	   Log.d("touch move isDrag = "+isDrag+" currMoveStyle = "+currMoveStyle+" currMoveStyle == MOVE_STYLE_FORBIDEN = "+(currMoveStyle == MOVE_STYLE_FORBIDEN)+" moveCount = "+moveCount);
    }
   	 moveCount++;

		//禁止移动和缩放
		if(currMoveStyle == MOVE_STYLE_FORBIDEN)
			return false;

   	if(isDrag){

 			//禁止移动
 			if(currMoveStyle == MOVE_STYLE_MOVE_FORBIDEN)
 				return false;

   		if(moveCount < 3)
   			return false;

      var touchPros = event.touches[0];
      moveX = parse2unit(touchPros.pageX - startX);
      moveY = parse2unit(touchPros.pageY - startY);
		
      var oldPos = parseTranslate($(focusObj));
    //   var oldScale = parseScale($(focusObj));

      endX = parseFloat(oldPos[0])+parseFloat(moveX);
      endY = parseFloat(oldPos[1])+parseFloat(moveY);

     var s;
     //禁止横向移动
     if(currMoveStyle == MOVE_STYLE_CROSS_MOVE_FORBIDEN || currMoveStyle == MOVE_STYLE_SCALE_AND_CROSS_MOVE_FORBIDEN )
       s = "translate("+parseFloat(oldPos[0])+","+endY+") scale("+oldScaleWhenTran+")";
     //禁止竖向移动
     else if(currMoveStyle == MOVE_STYLE_VERTICAL_MOVE_FORBIDEN || currMoveStyle == MOVE_STYLE_SCALE_AND_VERTICAL_MOVE_FORBIDEN )
     	 s = "translate("+endX+","+parseFloat(oldPos[1])+") scale("+oldScaleWhenTran+")";
     //都可以移动
     else
     	 s = "translate("+endX+","+endY+") scale("+oldScaleWhenTran+")";

      $(focusObj).attr("transform",s);
	 	  startX = touchPros.pageX;
	 	  startY = touchPros.pageY;

    }else if(isZoom){
  	   //禁止缩放
 			if(currMoveStyle == MOVE_STYLE_SCALE_FORBIDEN || currMoveStyle == MOVE_STYLE_SCALE_AND_VERTICAL_MOVE_FORBIDEN || currMoveStyle == MOVE_STYLE_SCALE_AND_CROSS_MOVE_FORBIDEN)
 				return false;

    	var oldPos = parseTranslate($(focusObj));
			var oldScale = parseScale($(focusObj));

  		var newDistance = getDistance(event);
  		var newScale;

  		if(Math.abs(newDistance - lastDistance) < 8)
  			return false;


  		var scaleUp = newDistance>lastDistance?true:false;
			var distance = Math.abs(newDistance - oldDistance);


			var changeX;
			var changeY;
			if(newDistance >= oldDistance){
					changeX = parseFloat(-distance/oldWidth*svgWidth/2);
					changeY = parseFloat(-distance/oldWidth*svgHeight/2);
					newScale = parseFloat(distance/oldWidth+1);
			}else{
					changeX = distance/oldWidth*svgWidth/2;
					changeY = distance/oldWidth*svgHeight/2;
					newScale = 1-parseFloat(distance/oldWidth);
			}

			if(parseFloat(parseFloat(newScale)+oldScaleWhenScale) < 0.1)
				return false; //缩小最小值为0.1倍

			var newPositionx = parseFloat(parseFloat(oldPosWhenScale[0])+parseFloat(changeX));
			var newPositiony = parseFloat(parseFloat(oldPosWhenScale[1])+parseFloat(changeY));
            if (DEBUG) {
			 Log.d("touch  newPosition = "+newPositionx+" newPositiony = "+newPositiony+" oldScaleWhenScale = "+oldScaleWhenScale+" width = "+$(focusObj).width());
            }
			var	trasform = "translate("+newPositionx+","+newPositiony+") scale("+parseFloat(parseFloat(newScale)+oldScaleWhenScale)+")";

      $(focusObj).attr("transform",trasform);
      if (DEBUG) {
          Log.d("touch parseInt(oldPosWhenScale[0]+changeX) = "+parseFloat(oldPosWhenScale[0]+changeX)+"  ddd  "+parseFloat(oldPosWhenScale[0]+parseFloat(changeX))+" width = "+$(focusObj).width());
          Log.d("touch new oldDistance = "+oldDistance+" newDistance = "+newDistance+" distance = "+distance+" oldPosWhenScale[0] = "+oldPosWhenScale[0]+" changeX = "+changeX+" newScale = "+newScale+" oldWidth = "+oldWidth+" transform = "+$(focusObj).attr("transform"));
      }

      lastDistance = newDistance;
    }

    return false;
  });

  $("#contentDIV") .on("touchend",function(event){
    if (DEBUG) {
    	Log.d("touch end event.touches.length = "+event.touches.length);
    }

     if(event.touches.length == 1){ //双指变单指情况
	  		isDrag = true;
	  		isZoom = false;

	  		var s = parseScale($(focusObj))[0];
	      var touchPros = event.touches[0];
	      startX = touchPros.pageX;
	      startY = touchPros.pageY;
	      oldScaleWhenTran = s;

	  }else if(event.touches.length > 1){
	  		isDrag = false;
	  		isZoom = true;
	  }
  	moveCount = 0;

  //	return true;
  });

}



function focusToPerson(){
	changeFocusObj($("#person"));
	changeMoveStyle(MOVE_STYLE_DEFAULT);
}
function focusToEye(){
	changeFocusObj($("#eye"));
	changeMoveStyle(MOVE_STYLE_DEFAULT);
}
function focusToEyebrow(){
	changeFocusObj($("#eyebrow"));
	changeMoveStyle(MOVE_STYLE_DEFAULT);
}
function focusToNose(){
	changeFocusObj($("#nose"));
	changeMoveStyle(MOVE_STYLE_DEFAULT);
}
function focusToMouth(){
	changeFocusObj($("#mouth"));
	changeMoveStyle(MOVE_STYLE_DEFAULT);
}
function focusToHat(){
	changeFocusObj($("#hat"));
	changeMoveStyle(MOVE_STYLE_DEFAULT);
}
function focusToHairpin(){
	changeFocusObj($("#hairpin"));
	changeMoveStyle(MOVE_STYLE_DEFAULT);
}
function focusToGlass(){
	changeFocusObj($("#glass"));
	changeMoveStyle(MOVE_STYLE_DEFAULT);
}
function focusToFace(){
	changeFocusObj($("#face"));
	changeMoveStyle(MOVE_STYLE_FORBIDEN);
}
function focusToHair(){
	changeFocusObj($("#frontHair"));
	changeMoveStyle(MOVE_STYLE_FORBIDEN);
}
function focusToUpperbody(){
	changeFocusObj($("#upperbody"));
	changeMoveStyle(MOVE_STYLE_FORBIDEN);
}

function focusToLowerbody(){
	changeFocusObj($("#lowerbody"));
	changeMoveStyle(MOVE_STYLE_FORBIDEN);
}

function focusToAllBody(){
    changeFocusObj($("#allbody"));
    changeMoveStyle(MOVE_STYLE_FORBIDEN);
}


function saveTransform(){
	var personTransform = $("#person").attr("transform");

	var hairTransform = $("#hair").attr("transform");
	var hairColorTransform = "";
	var faceTransform = "";
	var faceColorTransform = "";

	var eyebrowTransform = $("#eyebrow").attr("transform");
	var eyeTransform = $("#eye").attr("transform");
	var noseTransform = $("#nose").attr("transform");
	var mouthTransform = $("#mouth").attr("transform");

	var hatTransform = $("#hat").attr("transform");
	var hairPinTransform = $("#hairpin").attr("transform");
	var glassTransform = $("#glass").attr("transform");
	var beardTransform = $("#beard").attr("transform");

	var moleAndScarTransform = "";
	var upperBodyTransform = $("#upperbody").attr("transform");
	var lowerBodyTransform = $("#lowerbody").attr("transform");
	var bodyTransform = "";

	var bgTransform = "";
	var bgViewpointTransform = "";
	var bgBubbleTransform = "";
	var bgDecorationTransform = "";
	var blushTransform = "";

  if (window.baidu) {
		baidu.saveTransform(personTransform,
												hairTransform,hairColorTransform,faceTransform,faceColorTransform,
												eyebrowTransform,eyeTransform,noseTransform,mouthTransform,
												hatTransform,hairPinTransform,glassTransform,beardTransform,
												moleAndScarTransform,upperBodyTransform,lowerBodyTransform,bodyTransform,
												bgTransform,bgViewpointTransform,bgBubbleTransform,bgDecorationTransform,
												blushTransform
												);
	}
}
